-- http://xanadu.khnet.info
PIN = 4 --  data pin, GPIO2
APIKEY="ZADAT_APIKEY"

tmr.alarm(0,100, 1, function() 
    if wifi.sta.status() == 5 then
        print(wifi.sta.getip())
        tmr.stop(0)
        dht22 = require("dht22")
        dht22.read(PIN)
        t = dht22.getTemperature()
        h = dht22.getHumidity()
        sendline=""
        if h == nil then
            sendline="GET /update?key="..APIKEY.."&field3=1 HTTP/1.1\r\n"
            print("DHT Error")
        else
            t = t / 10
            h = h / 10
            sendline="GET /update?key="..APIKEY.."&field1="..t.."&field2="..h.." HTTP/1.1\r\n"
            print("DHT OK "..t.." "..h)
        end
        conn=net.createConnection(net.TCP, 0) 
        conn:on("receive", function(conn, payload) print(payload) end)
        -- api.thingspeak.com 184.106.153.149
        conn:connect(80,'184.106.153.149') 
        conn:send(sendline) 
        conn:send("Host: api.thingspeak.com\r\n") 
        conn:send("Accept: */*\r\n") 
        conn:send("User-Agent: Mozilla/4.0 (compatible; esp8266 Lua; Windows NT 5.1)\r\n")
        conn:send("\r\n")
        conn:on("sent",function(conn)
            print("Closing connection")
            conn:close()
        end)
        conn:on("disconnection", function(conn)
            -- release module
            dht22 = nil
            package.loaded["dht22"]=nil
            --sleep for 1 mins
            print("Go to sleep")
            tmr.alarm(0, 60000, 1, function() sendData() end )
        end)
    end
end)